Orientation in EJ2 JavaScript Tab control

26 Dec 202414 minutes to read

This section explains how to modify the position and modes of the Tab header.

The Tab component allows placing the header section at different positions using the headerPlacement property. The available positions are as follows:

  • Top: Tab header items are arranged horizontally, and their content is placed below the header.
  • Bottom: Tab header items are arranged horizontally, and their content is placed above the header.
  • Left: Tab header items are arranged vertically, and their content is placed to the right of the header.
  • Right: Tab header items are arranged vertically, and their content is placed to the left of the header.

The Tab component is also adaptable to the available space when the tab items exceed the view space. You can customize the overflow modes using the overflowMode property. The available modes are:

  • Scrollable
  • Popup
//Initialize Tab component
var tabObj = new ej.navigations.Tab({
    heightAdjustMode: 'None',
    height: 150,
    width: 700,
    items: [
        {
            header: { 'text': 'HTML' },
            content: 'HyperText Markup Language, commonly referred to as HTML, is the standard markup language used to create web ' +
                'pages. Along with CSS, and JavaScript, HTML is a cornerstone technology, used by most websites to create visually ' +
                'engaging web pages, user interfaces for web applications, and user interfaces for many mobile applications.[1] Web ' +
                'browsers can read HTML files and render them into visible or audible web pages. HTML describes the structure of a ' +
                'website semantically along with cues for presentation, making it a markup language, rather than a programming language.'
        },
        {
            header: { 'text': 'C Sharp(C#)' },
            content: 'C# is intended to be a simple, modern, general-purpose, object-oriented programming language. Its development ' +
                'team is led by Anders Hejlsberg. The most recent version is C# 5.0, which was released on August 15, 2012.'
        },
        {
            header: { 'text': 'Java' },
            content: 'Java is a set of computer software and specifications developed by Sun Microsystems, later acquired by Oracle ' +
                'Corporation, that provides a system for developing application software and deploying it in a cross-platform computing ' +
                'environment. Java is used in a wide variety of computing platforms from embedded devices and mobile phones to ' +
                'enterprise servers and supercomputers. While less common, Java applets run in secure, sandboxed environments to ' +
                'provide many features of native applications and can be embedded in HTML pages.'
        },
        {
            header: { 'text': 'VB.Net' },
            content: 'The command-line compiler, VBC.EXE, is installed as part of the freeware .NET Framework SDK. Mono also ' +
                'includes a command-line VB.NET compiler. The most recent version is VB 2012, which was released on August 15, 2012.'
        },
        {
            header: { 'text': 'Xamarin' },
            content: 'Xamarin is a San Francisco, California based software company created in May 2011[3] by the engineers that ' +
                'created Mono,[4] Mono for Android and MonoTouch that are cross-platform implementations of the Common Language ' +
                'Infrastructure (CLI) and Common Language Specifications (often called Microsoft .NET). With a C#-shared codebase, ' +
                'developers can use Xamarin tools to write native Android, iOS, and Windows apps with native user interfaces and share ' +
                'code across multiple platforms.[5] Xamarin has over 1 million developers in more than 120 countries around the World ' +
                'as of May 2015.'
        },
        {
            header: { 'text': 'ASP.NET' },
            content: 'ASP.NET is an open-source server-side web application framework designed for web development to produce ' +
                'dynamic web pages. It was developed by Microsoft to allow programmers to build dynamic web sites, web applications ' +
                'and web services. It was first released in January 2002 with version 1.0 of the .NET Framework, and is the successor ' +
                'to Microsoft\'\s Active Server Pages (ASP) technology. ASP.NET is built on the Common Language Runtime (CLR), allowing ' +
                'programmers to write ASP.NET code using any supported .NET language. The ASP.NET SOAP extension framework allows ' +
                'ASP.NET components to process SOAP messages.'
        },
        {
            header: { 'text': 'ASP.NET MVC' },
            content: 'The ASP.NET MVC is a web application framework developed by Microsoft, which implements the ' +
                'model–view–controller (MVC) pattern. It is open-source software, apart from the ASP.NET Web Forms component which is ' +
                'proprietary. In the later versions of ASP.NET, ASP.NET MVC, ASP.NET Web API, and ASP.NET Web Pages (a platform using ' +
                'only Razor pages) will merge into a unified MVC 6.The project is called ASP.NET vNext.'
        },
        {
            header: { 'text': 'JavaScript' },
            content: 'JavaScript (JS) is an interpreted computer programming language. It was originally implemented as part of ' +
                'web browsers so that client-side scripts could interact with the user, control the browser, communicate ' +
                'asynchronously, and alter the document content that was displayed.[5] More recently, however, it has become common in ' +
                'both game development and the creation of desktop applications.'
        }
    ]
});
tabObj.appendTo('#element');

var headerPosition = new ej.dropdowns.DropDownList({
    change: function (e) {
        tabObj.headerPlacement = e.itemData.text;
        tabObj.dataBind();
    }
});
headerPosition.appendTo('#headerPosition');

var mode = new ej.dropdowns.DropDownList({
    change: function (arg) {
        tabObj.overflowMode = arg.itemData.text;
        tabObj.dataBind();
    }
});
mode.appendTo('#Mode');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Tab</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Tab Controls">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/material.css" rel="stylesheet">
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" type="text/css">
    <link href="index.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/31.2.12/dist/ej2.min.js" type="text/javascript"></script>
    <style>
        .e-content .e-item {
            font-size: 12px;
            margin: 10px;
            text-align: justify;
        }
    
        #element {
            margin-top: 80px;
            margin-left: 80px;
        }
    
        #default {
            margin-top: 15px;
        }
    
        #default .row {
            margin-right: 20px;
            margin-left: 20px;
        }
    </style>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="default" style="padding-top:20px">
            <div class="row" style="float:left">
                <label> Header Position </label>
                <div>
                    <select id="headerPosition">
                        <option value="top">Top</option>
                        <option value="bottom">Bottom</option>
                        <option value="left">Left</option>
                        <option value="right">Right</option>
                    </select>
                </div>
            </div>
            <div class="row" style="float:right">
                <label> Mode </label>
                <div>
                    <select id="Mode">
                        <option value="scrollable">Scrollable</option>
                        <option value="popup">Popup</option>
                    </select>
                </div>
            </div>
        </div>
        <div id="element"></div>
        <br>
        <br>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Orientation in Angular Tab component

22 Sep 202513 minutes to read

This section explains how to modify the position and modes of Tab header placement for optimal user experience and layout adaptation.

The Tab component allows placing the header section at different positions by using the headerPlacement property. The available positions are as follows:

  • Top: Tab header items can be arranged horizontally, and their content can be placed after the header.
  • Bottom: Tab header items can be arranged horizontally, and their content can be placed before the header.
  • Left: Tab header items can be arranged vertically, and their content can be placed after the header.
  • Right: Tab header items can be arranged vertically, and their content can be placed before the header.

The Tab component automatically adapts to available space when tab items exceed the viewport. You can customize the overflow behavior using the overflowMode property. The available modes are as follows:

  • Scrollable
  • Popup
<div id='container'>
    <div id="default" style="padding-top:20px">
        <div class='row' style="float:left">
            <label> Header Position </label>
            <div>
                <ejs-dropdownlist #dropDownPosition (change)="positionChange($event)" id='headerPosition' [dataSource]='PositionDB' [value]='positionValue' [fields]='positionFields' index='0'>
                </ejs-dropdownlist>
            </div>
        </div>
        <div class='row' style="float:right">
            <label> Mode </label>
            <div>
                <ejs-dropdownlist #dropDownMode (change)="modeChange($event)" id='Mode' [dataSource]='ModeDB' [value]='modeValue' [fields]='modeFields' index='0'>
                </ejs-dropdownlist>
            </div>
        </div>
    </div>
        <ejs-tab #element id="element" heightAdjustMode='None' height='150px' width='700px'>
            <e-tabitems>
                <e-tabitem [header]='headerText[0]' [content]="content0"></e-tabitem>
                <e-tabitem [header]='headerText[1]' [content]="content1"></e-tabitem>
                <e-tabitem [header]='headerText[2]' [content]="content2"></e-tabitem>
                <e-tabitem [header]='headerText[3]' [content]="content3"></e-tabitem>
                <e-tabitem [header]='headerText[4]' [content]="content4"></e-tabitem>
                <e-tabitem [header]='headerText[5]' [content]="content5"></e-tabitem>
                <e-tabitem [header]='headerText[6]' [content]="content6"></e-tabitem>
                <e-tabitem [header]='headerText[7]' [content]="content7"></e-tabitem>
            </e-tabitems>
        </ejs-tab>
        <br/>
        <br/>
</div>
import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { FormsModule } from '@angular/forms'
import { TabAllModule } from '@syncfusion/ej2-angular-navigations'
import { DropDownListAllModule } from '@syncfusion/ej2-angular-dropdowns'



import { Component, ViewChild, OnInit, ViewEncapsulation } from '@angular/core';
import { DropDownListComponent } from '@syncfusion/ej2-angular-dropdowns';
import { rippleEffect } from '@syncfusion/ej2-base';
import { TabComponent } from '@syncfusion/ej2-angular-navigations';

@Component({
imports: [
        FormsModule,TabAllModule,DropDownListAllModule
    ],


standalone: true,
    selector: 'app-container',
    templateUrl: 'app/app.component.html',
    encapsulation: ViewEncapsulation.None
})

export class AppComponent implements OnInit {
    ngOnInit(): void {
    }

    @ViewChild('element') tabObj?: TabComponent;
    @ViewChild('dropDownMode') dropMode?: DropDownListComponent;
    @ViewChild('dropDownPosition') dropPosition?: DropDownListComponent;

    public ModeDB = [{ id: 'scrollable', mode: 'Scrollable' },
        { id: 'popup', mode: 'Popup' }];

    public PositionDB = [{ id: 'top', position: 'Top' }, { id: 'bottom', position: 'Bottom' },
        { id: 'left', position: 'Left' }, { id: 'right', position: 'Right' }];

    public positionFields: Object = { text: 'position', value: 'id' };

    public modeFields: Object = { text: 'mode', value: 'id' };

    public positionValue: string = 'top';

    public modeValue: string = 'scrollable';

     public headerText: Object = [{ 'text': 'HTML' }, { 'text': 'C Sharp(C#)' },{ 'text': 'Java' },{ 'text': 'VB.Net' }, { 'text': 'Xamarin' }, { 'text': 'ASP.NET' },
    { 'text': 'ASP.NET MVC' }, { 'text': 'JavaScript' }];
    public content0: string = 'HyperText Markup Language, commonly referred to as HTML, is the standard markup language used to create web ' +
                'pages. Along with CSS, and JavaScript, HTML is a cornerstone technology, used by most websites to create visually ' +
                'engaging web pages, user interfaces for web applications, and user interfaces for many mobile applications.[1] Web ' +
                'browsers can read HTML files and render them into visible or audible web pages. HTML describes the structure of a ' +
                'website semantically along with cues for presentation, making it a markup language, rather than a programming language.';

    public content1: string = 'C# is intended to be a simple, modern, general-purpose, object-oriented programming language. Its development ' +
                'team is led by Anders Hejlsberg. The most recent version is C# 5.0, which was released on August 15, 2012.';

    public content2: string = 'Java is a set of computer software and specifications developed by Sun Microsystems, later acquired by Oracle ' +
                'Corporation, that provides a system for developing application software and deploying it in a cross-platform computing ' +
                'environment. Java is used in a wide variety of computing platforms from embedded devices and mobile phones to ' +
                'enterprise servers and supercomputers. While less common, Java applets run in secure, sandboxed environments to ' +
                'provide many features of native applications and can be embedded in HTML pages.';

    public content3: string = 'The command-line compiler, VBC.EXE, is installed as part of the freeware .NET Framework SDK. Mono also ' +
                'includes a command-line VB.NET compiler. The most recent version is VB 2012, which was released on August 15, 2012.';

    public content4: string = 'Xamarin is a San Francisco, California based software company created in May 2011[3] by the engineers that ' +
                'created Mono,[4] Mono for Android and MonoTouch that are cross-platform implementations of the Common Language ' +
                'Infrastructure (CLI) and Common Language Specifications (often called Microsoft .NET). With a C#-shared codebase, ' +
                'developers can use Xamarin tools to write native Android, iOS, and Windows apps with native user interfaces and share ' +
                'code across multiple platforms.[5] Xamarin has over 1 million developers in more than 120 countries around the World ' +
                'as of May 2015.';

    public content5: string = 'ASP.NET is an open-source server-side web application framework designed for web development to produce ' +
                'dynamic web pages. It was developed by Microsoft to allow programmers to build dynamic web sites, web applications ' +
                'and web services. It was first released in January 2002 with version 1.0 of the .NET Framework, and is the successor ' +
                'to Microsoft\'\s Active Server Pages (ASP) technology. ASP.NET is built on the Common Language Runtime (CLR), allowing ' +
                'programmers to write ASP.NET code using any supported .NET language. The ASP.NET SOAP extension framework allows ' +
                'ASP.NET components to process SOAP messages.';

    public content6: string = 'The ASP.NET MVC is a web application framework developed by Microsoft, which implements the ' +
                'model–view–controller (MVC) pattern. It is open-source software, apart from the ASP.NET Web Forms component which is ' +
                'proprietary. In the later versions of ASP.NET, ASP.NET MVC, ASP.NET Web API, and ASP.NET Web Pages (a platform using ' +
                'only Razor pages) will merge into a unified MVC 6.The project is called ASP.NET vNext.';

    public content7: string = 'JavaScript (JS) is an interpreted computer programming language. It was originally implemented as part of ' +
                'web browsers so that client-side scripts could interact with the user, control the browser, communicate ' +
                'asynchronously, and alter the document content that was displayed.[5] More recently, however, it has become common in ' +
                'both game development and the creation of desktop applications.';

    public modeChange(e: Object): void {
        (this.tabObj as TabComponent).overflowMode  = this.dropMode?.text as any;
        (this.tabObj as TabComponent).dataBind();
    }

    public positionChange(e: Object): void {
        (this.tabObj as TabComponent).headerPlacement = this.dropPosition?.text as any;
        (this.tabObj as TabComponent).dataBind();
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Orientation in Vue Tab component

25 May 202421 minutes to read

This section explains about modifying the position and modes of Tab header.

It allows placing the header section inside the Tab component at different positions by using the headerPlacement property. The available positions are as follows:

  • Top: Tab header items can be arranged horizontally, and their content can be placed after the header.
  • Bottom: Tab header items can be arranged horizontally, and their content can be placed before the header.
  • Left: Tab header items can be arranged vertically, and their content can be placed after the header.
  • Right: Tab header items can be arranged vertically, and their content can be placed before the header.

It is also adaptable to the available space when the tab items exceed the view space. You can customize the modes by using overflowMode property. The available modes are as follows:

  • Scrollable
  • Popup
<template>
  <div id='container'>
    <div id="default" style="padding-top:20px">
      <div class='row' style="float:left">
        <label> Header Position </label>
        <div>
          <ejs-dropdownlist id="headerPosition" ref='headerPosition' :dataSource='headerData' :change='positionChange'
            :value='placeValue' :fields='placeFields'></ejs-dropdownlist>
        </div>
      </div>
      <div class='row' style="float:right">
        <label> Mode </label>
        <div>
          <ejs-dropdownlist id="Mode" ref='mode' :dataSource='modeData' :change='modeChange' :value='value'
            :fields='fields'></ejs-dropdownlist>
        </div>
      </div>
    </div>
    <br />
    <div>
      <ejs-tab id='element' ref="element" heightAdjustMode='None' height='150px' width='700px'>
        <e-tabitems>
          <e-tabitem :header='headerText0' :content="content0"></e-tabitem>
          <e-tabitem :header='headerText1' :content="content1"></e-tabitem>
          <e-tabitem :header='headerText2' :content="content2"></e-tabitem>
          <e-tabitem :header='headerText3' :content="content3"></e-tabitem>
          <e-tabitem :header='headerText4' :content="content4"></e-tabitem>
          <e-tabitem :header='headerText5' :content="content5"></e-tabitem>
          <e-tabitem :header='headerText6' :content="content6"></e-tabitem>
          <e-tabitem :header='headerText7' :content="content7"></e-tabitem>
        </e-tabitems>
      </ejs-tab>
    </div>
  </div>
</template>
<script setup>

import { TabComponent as EjsTab, TabItemsDirective as ETabitems, TabItemDirective as ETabitem } from '@syncfusion/ej2-vue-navigations';
import { DropDownListComponent as EjsDropdownlist } from "@syncfusion/ej2-vue-dropdowns";

const modeData = [{ id: 'scrollable', mode: 'Scrollable' }, { id: 'popup', mode: 'Popup' }];
const headerData = [{ id: 'top', position: 'Top' }, { id: 'bottom', position: 'Bottom' }, { id: 'left', position: 'Left' }, { id: 'right', position: 'Right' }];
const fields = { text: 'mode', value: 'id' };
const placeFields = { text: 'position', value: 'id' };
const value = 'scrollable';
const placeValue = 'top';
const headerText0 = { text: 'HTML' };
const headerText1 = { text: 'C Sharp(C#)' };
const headerText2 = { text: 'Java' };
const headerText3 = { text: 'VB.Net' };
const headerText4 = { text: 'Xamarin' };
const headerText5 = { text: 'ASP.NET' };
const headerText6 = { text: 'ASP.NET MVC' };
const headerText7 = { text: 'JavaScript' };

const content0 = 'HyperText Markup Language, commonly referred to as HTML, is the standard markup language used to ' +
  'create web pages. Along with CSS, and JavaScript, HTML is a cornerstone technology, used by most websites to create visually ' +
  'engaging web pages, user interfaces for web applications, and user interfaces for many mobile applications.[1] Web ' +
  'browsers can read HTML files and render them into visible or audible web pages. HTML describes the structure of a ' +
  'website semantically along with cues for presentation, making it a markup language, rather than a programming language.';

const content1 = 'C# is intended to be a simple, modern, general-purpose, object-oriented programming language. Its ' +
  'development team is led by Anders Hejlsberg. The most recent version is C# 5.0, which was released on August 15, 2012.';

const content2 = 'Java is a set of computer software and specifications developed by Sun Microsystems, later acquired ' +
  'by Oracle Corporation, that provides a system for developing application software and deploying it in a cross-platform ' +
  'computing environment. Java is used in a wide variety of computing platforms from embedded devices and mobile phones to ' +
  'enterprise servers and supercomputers. While less common, Java applets run in secure, sandboxed environments to ' +
  'provide many features of native applications and can be embedded in HTML pages.';

const content3 = 'The command-line compiler, VBC.EXE, is installed as part of the freeware .NET Framework SDK. Mono also ' +
  'includes a command-line VB.NET compiler. The most recent version is VB 2012, which was released on August 15, 2012.';

const content4 = 'Xamarin is a San Francisco, California based software company created in May 2011[3] by the engineers ' +
  'that created Mono,[4] Mono for Android and MonoTouch that are cross-platform implementations of the Common Language ' +
  'Infrastructure (CLI) and Common Language Specifications (often called Microsoft .NET). With a C#-shared codebase, ' +
  'developers can use Xamarin tools to write native Android, iOS, and Windows apps with native user interfaces and share ' +
  'code across multiple platforms.[5] Xamarin has over 1 million developers in more than 120 countries around the World ' +
  'as of May 2015.';

const content5 = 'ASP.NET is an open-source server-side web application framework designed for web development to produce ' +
  'dynamic web pages. It was developed by Microsoft to allow programmers to build dynamic web sites, web applications ' +
  'and web services. It was first released in January 2002 with version 1.0 of the .NET Framework, and is the successor ' +
  'to Microsoft\'s Active Server Pages (ASP) technology. ASP.NET is built on the Common Language Runtime (CLR), allowing ' +
  'programmers to write ASP.NET code using any supported .NET language. The ASP.NET SOAP extension framework allows ' +
  'ASP.NET components to process SOAP messages.';

const content6 = 'The ASP.NET MVC is a web application framework developed by Microsoft, which implements the ' +
  'model–view–controller (MVC) pattern. It is open-source software, apart from the ASP.NET Web Forms component which is ' +
  'proprietary. In the later versions of ASP.NET, ASP.NET MVC, ASP.NET Web API, and ASP.NET Web Pages (a platform using ' +
  'only Razor pages) will merge into a unified MVC 6.The project is called ASP.NET vNext.';

const content7 = 'JavaScript (JS) is an interpreted computer programming language. It was originally implemented as ' +
  'part of web browsers so that client-side scripts could interact with the user, control the browser, communicate ' +
  'asynchronously, and alter the document content that was displayed.[5] More recently, however, it has become common in ' +
  'both game development and the creation of desktop applications.';

const positionChange = () => {
  let tabObj = document.getElementById('element');
  let placement = (document.getElementById('headerPosition')).value;
  tabObj.ej2_instances[0].headerPlacement = placement;
  tabObj.ej2_instances[0].dataBind();
};
const modeChange = () => {
  let tabObj = document.getElementById('element');
  let placement = (document.getElementById('Mode')).value;
  tabObj.ej2_instances[0].overflowMode = placement;
  tabObj.ej2_instances[0].dataBind();
};


</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-dropdowns/styles/material.css";

#app {
  color: #008cff;
  height: 40px;
  left: 45%;
  position: absolute;
  top: 45%;
  width: 30%;
}

.e-content .e-item {
  font-size: 12px;
  margin: 10px;
  text-align: justify;
}

#element {
  margin-top: 80px;
  margin-left: 80px;
}

#default {
  margin-top: 15px;
}
</style>
<template>
  <div id='container'>
    <div id="default" style="padding-top:20px">
      <div class='row' style="float:left">
        <label> Header Position </label>
        <div>
          <ejs-dropdownlist id="headerPosition" ref='headerPosition' :dataSource='headerData' :change='positionChange'
            :value='placeValue' :fields='placeFields'></ejs-dropdownlist>
        </div>
      </div>
      <div class='row' style="float:right">
        <label> Mode </label>
        <div>
          <ejs-dropdownlist id="Mode" ref='mode' :dataSource='modeData' :change='modeChange' :value='value'
            :fields='fields'></ejs-dropdownlist>
        </div>
      </div>
    </div>
    <br />
    <div>
      <ejs-tab id='element' ref="element" heightAdjustMode='None' height='150px' width='700px'>
        <e-tabitems>
          <e-tabitem :header='headerText0' :content="content0"></e-tabitem>
          <e-tabitem :header='headerText1' :content="content1"></e-tabitem>
          <e-tabitem :header='headerText2' :content="content2"></e-tabitem>
          <e-tabitem :header='headerText3' :content="content3"></e-tabitem>
          <e-tabitem :header='headerText4' :content="content4"></e-tabitem>
          <e-tabitem :header='headerText5' :content="content5"></e-tabitem>
          <e-tabitem :header='headerText6' :content="content6"></e-tabitem>
          <e-tabitem :header='headerText7' :content="content7"></e-tabitem>
        </e-tabitems>
      </ejs-tab>
    </div>
  </div>
</template>
<script>

import { TabComponent, TabItemsDirective, TabItemDirective } from '@syncfusion/ej2-vue-navigations';
import { DropDownListComponent } from "@syncfusion/ej2-vue-dropdowns";

export default {
  name: "App",
  components: {
    "ejs-dropdownlist": DropDownListComponent,
    "ejs-tab": TabComponent,
    "e-tabitems": TabItemsDirective,
    "e-tabitem": TabItemDirective
  },
  data: function () {
    return {
      modeData: [{ id: 'scrollable', mode: 'Scrollable' }, { id: 'popup', mode: 'Popup' }],
      headerData: [{ id: 'top', position: 'Top' }, { id: 'bottom', position: 'Bottom' }, { id: 'left', position: 'Left' }, { id: 'right', position: 'Right' }],
      fields: { text: 'mode', value: 'id' },
      placeFields: { text: 'position', value: 'id' },
      value: 'scrollable',
      placeValue: 'top',
      headerText0: { text: 'HTML' },
      headerText1: { text: 'C Sharp(C#)' },
      headerText2: { text: 'Java' },
      headerText3: { text: 'VB.Net' },
      headerText4: { text: 'Xamarin' },
      headerText5: { text: 'ASP.NET' },
      headerText6: { text: 'ASP.NET MVC' },
      headerText7: { text: 'JavaScript' },
      content0: 'HyperText Markup Language, commonly referred to as HTML, is the standard markup language used to ' +
        'create web pages. Along with CSS, and JavaScript, HTML is a cornerstone technology, used by most websites to create visually ' +
        'engaging web pages, user interfaces for web applications, and user interfaces for many mobile applications.[1] Web ' +
        'browsers can read HTML files and render them into visible or audible web pages. HTML describes the structure of a ' +
        'website semantically along with cues for presentation, making it a markup language, rather than a programming language.',

      content1: 'C# is intended to be a simple, modern, general-purpose, object-oriented programming language. Its ' +
        'development team is led by Anders Hejlsberg. The most recent version is C# 5.0, which was released on August 15, 2012.',

      content2: 'Java is a set of computer software and specifications developed by Sun Microsystems, later acquired ' +
        'by Oracle Corporation, that provides a system for developing application software and deploying it in a cross-platform ' +
        'computing environment. Java is used in a wide variety of computing platforms from embedded devices and mobile phones to ' +
        'enterprise servers and supercomputers. While less common, Java applets run in secure, sandboxed environments to ' +
        'provide many features of native applications and can be embedded in HTML pages.',

      content3: 'The command-line compiler, VBC.EXE, is installed as part of the freeware .NET Framework SDK. Mono also ' +
        'includes a command-line VB.NET compiler. The most recent version is VB 2012, which was released on August 15, 2012.',

      content4: 'Xamarin is a San Francisco, California based software company created in May 2011[3] by the engineers ' +
        'that created Mono,[4] Mono for Android and MonoTouch that are cross-platform implementations of the Common Language ' +
        'Infrastructure (CLI) and Common Language Specifications (often called Microsoft .NET). With a C#-shared codebase, ' +
        'developers can use Xamarin tools to write native Android, iOS, and Windows apps with native user interfaces and share ' +
        'code across multiple platforms.[5] Xamarin has over 1 million developers in more than 120 countries around the World ' +
        'as of May 2015.',

      content5: 'ASP.NET is an open-source server-side web application framework designed for web development to produce ' +
        'dynamic web pages. It was developed by Microsoft to allow programmers to build dynamic web sites, web applications ' +
        'and web services. It was first released in January 2002 with version 1.0 of the .NET Framework, and is the successor ' +
        'to Microsoft\'s Active Server Pages (ASP) technology. ASP.NET is built on the Common Language Runtime (CLR), allowing ' +
        'programmers to write ASP.NET code using any supported .NET language. The ASP.NET SOAP extension framework allows ' +
        'ASP.NET components to process SOAP messages.',

      content6: 'The ASP.NET MVC is a web application framework developed by Microsoft, which implements the ' +
        'model–view–controller (MVC) pattern. It is open-source software, apart from the ASP.NET Web Forms component which is ' +
        'proprietary. In the later versions of ASP.NET, ASP.NET MVC, ASP.NET Web API, and ASP.NET Web Pages (a platform using ' +
        'only Razor pages) will merge into a unified MVC 6.The project is called ASP.NET vNext.',

      content7: 'JavaScript (JS) is an interpreted computer programming language. It was originally implemented as ' +
        'part of web browsers so that client-side scripts could interact with the user, control the browser, communicate ' +
        'asynchronously, and alter the document content that was displayed.[5] More recently, however, it has become common in ' +
        'both game development and the creation of desktop applications.',

    }
  },
  methods: {
    positionChange: function () {
      let tabObj = document.getElementById('element');
      let placement = (document.getElementById('headerPosition')).value;
      tabObj.ej2_instances[0].headerPlacement = placement;
      tabObj.ej2_instances[0].dataBind();
    },
    modeChange: function () {
      let tabObj = document.getElementById('element');
      let placement = (document.getElementById('Mode')).value;
      tabObj.ej2_instances[0].overflowMode = placement;
      tabObj.ej2_instances[0].dataBind();
    }
  }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-dropdowns/styles/material.css";

#app {
  color: #008cff;
  height: 40px;
  left: 45%;
  position: absolute;
  top: 45%;
  width: 30%;
}

.e-content .e-item {
  font-size: 12px;
  margin: 10px;
  text-align: justify;
}

#element {
  margin-top: 80px;
  margin-left: 80px;
}

#default {
  margin-top: 15px;
}
</style>

Orientation in React Tab component

29 Aug 202324 minutes to read

This section explains about modifying the position and modes of Tab header.

It allows placing the header section inside the Tab component at different positions by using the headerPlacement property. The available positions are as follows:

  • Top: Tab header items can be arranged horizontally, and their content can be placed after the header.
  • Bottom: Tab header items can be arranged horizontally, and their content can be placed before the header.
  • Left: Tab header items can be arranged vertically, and their content can be placed after the header.
  • Right: Tab header items can be arranged vertically, and their content can be placed before the header.

It is also adaptable to the available space when the tab items exceed the view space. You can customize the modes by using overflowMode property. The available modes are as follows:

  • Scrollable
  • Popup
import * as React from "react";
import { useRef } from 'react';
import * as ReactDOM from 'react-dom';
import { ChangeEventArgs, DropDownListComponent } from '@syncfusion/ej2-react-dropdowns';
import { TabComponent, TabItemDirective, TabItemsDirective } from '@syncfusion/ej2-react-navigations';

const ReactApp = () => {
  const tabObj = useRef(null);
  const headerPosition = useRef(null);
  const orientation = useRef(null);

  let headerText= [{ text: "HTML" }, { text: "C Sharp(C#)" }, { text: "Java" }, { text: "VB.Net" },
  { text: "Xamarin" }, { text: "ASP.NET" }, { text: "ASP.NET MVC" }, { text: "JavaScript" }];

  let fields = { text: 'text', value: 'value' };

  let headerData = [{ 'value': 'top', 'text': 'Top' }, { 'value': 'bottom', 'text': 'Bottom' },
  { 'value': 'left', 'text': 'Left' }, { 'value': 'right', 'text': 'Right' }];

  let orientationData = [{ 'value': 'scrollable', 'text': 'Scrollable' }, { 'value': 'popup', 'text': 'Popup' }];

  let hdrVal = 'top';

  let orientationVal = 'scrollable';

  const changeOrientationMode = (e) => {
    let placement = headerPosition.current.value.charAt(0).toUpperCase() + headerPosition.current.value.slice(1);
    tabObj.current.headerPlacement = placement;
    tabObj.current.dataBind();
  }

  const changeOverflowMode = (e) => {
    let placement = orientation.current.value.charAt(0).toUpperCase() + orientation.current.value.slice(1);
    tabObj.current.overflowMode = placement;
    tabObj.current.dataBind();
  }

  const htmlcontent = () => {
    return <div>
      HyperText Markup Language, commonly referred to as HTML, is the standard markup
      language used to create web pages. Along with CSS, and JavaScript, HTML is a cornerstone
      technology, used by most websites to create visually engaging web pages, user interfaces
      for web applications, and user interfaces for many mobile applications.[1] Web browsers
      can read HTML files and render them into visible or audible web pages. HTML describes
      the structure of a website semantically along with cues for presentation, making it a
      markup language, rather than a programming language.
    </div>;
  }
  const csharpContent = () => {
    return <div>
      C# is intended to be a simple, modern, general-purpose, object-oriented programming language. Its development team is led by Anders Hejlsberg. The most recent version is C# 5.0, which was released on August 15, 2012.
    </div>;
  }
  const javaContent = () => {
    return <div>
      Java is a set of computer software and specifications developed by Sun Microsystems, later acquired by Oracle
      Corporation, that provides a system for developing application software and deploying it in a cross-platform computing
      environment. Java is used in a wide variety of computing platforms from embedded devices and mobile phones to
      enterprise servers and supercomputers. While less common, Java applets run in secure, sandboxed environments to
      provide many features of native applications and can be embedded in HTML pages.
    </div>;
  }
  const vbNetcontent = () => {
    return <div>
      The command-line compiler, VBC.EXE, is installed as part of the freeware .NET
      Framework SDK. Mono also includes a command-line VB.NET compiler. The most recent version
      is VB 2012, which was released on August 15, 2012.
    </div>;
  }
  const xamarinContent = () => {
    return <div>
      Xamarin is a San Francisco, California based software company created in May
      2011[3] by the engineers that created Mono,[4] Mono for Android and MonoTouch that are
      cross-platform implementations of the Common Language Infrastructure (CLI) and Common
      Language Specifications (often called Microsoft .NET). With a C#-shared codebase,developers
      can use Xamarin tools to write native Android, iOS, and Windows apps with native user interfaces
      and share code across multiple platforms.[5] Xamarin has over 1 million developers in more
      than 120 countries around the World as of May 2015.
    </div>;
  }
  const aspNetContent = () => {
    return <div>
      ASP.NET is an open-source server-side web application framework designed for web
      development to produce dynamic web pages. It was developed by Microsoft to allow programmers
      to build dynamic web sites, web applications and web services. It was first released in January
      2002 with version 1.0 of the .NET Framework, and is the successor to Microsoft Active Server
      Pages (ASP) technology. ASP.NET is built on the Common Language Runtime (CLR), allowing
      programmers to write ASP.NET code using any supported .NET language. The ASP.NET SOAP extension
      framework allows ASP.NET components to process SOAP messages.
    </div>;
  }
  const mvcContent = () => {
    return <div>
      The ASP.NET MVC is a web application framework developed by Microsoft, which implements
      the modelviewcontroller (MVC) pattern. It is open-source software, apart from the ASP.NET Web
      Forms component which is proprietary. In the later versions of ASP.NET, ASP.NET MVC, ASP.NET Web
      API, and ASP.NET Web Pages (a platform using only Razor pages) will merge into a unified MVC 6.
      The project is called ASP.NET vNext.
    </div>;
  }
  const javaScriptContent = () => {
    return <div>
      JavaScript (JS) is an interpreted computer programming language. It was originally
      implemented as part of web browsers so that client-side scripts could interact with the
      user, control the browser, communicate asynchronously, and alter the document content that
      was displayed.[5] More recently, however, it has become common in both game development
      and the creation of desktop applications.
    </div>;
  }

  return (
    <div>
      <div className='row' id='header'>
        <label> Header Position </label>
        <div>
          <DropDownListComponent ref={headerPosition} dataSource={headerData} fields={fields} value={hdrVal} width={'150'} change={changeOrientationMode} />
        </div>
      </div>
      <div className='row' id='mode'>
        <label> Mode </label>
        <div>
          <DropDownListComponent ref={orientation} dataSource={orientationData} fields={fields} value={orientationVal} width={'150'} change={changeOverflowMode} />
        </div>
      </div>
      <br /><br />
      <TabComponent id='default' heightAdjustMode='None' height={150} width='700' ref={tabObj}>
        <TabItemsDirective>
          <TabItemDirective header={headerText[0]} content={htmlcontent} />
          <TabItemDirective header={headerText[1]} content={csharpContent} />
          <TabItemDirective header={headerText[2]} content={javaContent} />
          <TabItemDirective header={headerText[3]} content={vbNetcontent} />
          <TabItemDirective header={headerText[4]} content={xamarinContent} />
          <TabItemDirective header={headerText[5]} content={aspNetContent} />
          <TabItemDirective header={headerText[6]} content={mvcContent} />
          <TabItemDirective header={headerText[7]} content={javaScriptContent} />
        </TabItemsDirective>
      </TabComponent>
    </div>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<ReactApp />);
import * as React from 'react';
import { useRef } from 'react';
import * as ReactDOM from 'react-dom';
import { ChangeEventArgs, DropDownListComponent } from '@syncfusion/ej2-react-dropdowns';
import { TabComponent, TabItemDirective, TabItemsDirective } from '@syncfusion/ej2-react-navigations';

const ReactApp = () => {
  const tabObj = useRef<TabComponent>(null);
  const headerPosition = useRef<DropDownListComponent>(null);
  const orientation = useRef<DropDownListComponent>(null);

  let headerText: any = [{ text: "HTML" }, { text: "C Sharp(C#)" }, { text: "Java" }, { text: "VB.Net" },
  { text: "Xamarin" }, { text: "ASP.NET" }, { text: "ASP.NET MVC" }, { text: "JavaScript" }];

  let fields: object = { text: 'text', value: 'value' };

  let headerData: any = [{ 'value': 'top', 'text': 'Top' }, { 'value': 'bottom', 'text': 'Bottom' },
  { 'value': 'left', 'text': 'Left' }, { 'value': 'right', 'text': 'Right' }];

  let orientationData: { [key: string]: Object }[] = [{ 'value': 'scrollable', 'text': 'Scrollable' }, { 'value': 'popup', 'text': 'Popup' }];

  let hdrVal: string = 'top';

  let orientationVal: string = 'scrollable';

  const changeOrientationMode = (e: ChangeEventArgs): void => {
    let placement: string = (headerPosition.current.value as string).charAt(0).toUpperCase() + (headerPosition.current.value as string).slice(1);
    tabObj.current.headerPlacement = placement as any;
    tabObj.current.dataBind();
  }

  const changeOverflowMode = (e: ChangeEventArgs): void => {
    let placement: string = (orientation.current.value as string).charAt(0).toUpperCase() + (orientation.current.value as string).slice(1);
    tabObj.current.overflowMode = placement as any;
    tabObj.current.dataBind();
  }

  const htmlcontent = () => {
    return <div>
      HyperText Markup Language, commonly referred to as HTML, is the standard markup
      language used to create web pages. Along with CSS, and JavaScript, HTML is a cornerstone
      technology, used by most websites to create visually engaging web pages, user interfaces
      for web applications, and user interfaces for many mobile applications.[1] Web browsers
      can read HTML files and render them into visible or audible web pages. HTML describes
      the structure of a website semantically along with cues for presentation, making it a
      markup language, rather than a programming language.
    </div>;
  }
  const csharpContent = () => {
    return <div>
      C# is intended to be a simple, modern, general-purpose, object-oriented programming language. Its development team is led by Anders Hejlsberg. The most recent version is C# 5.0, which was released on August 15, 2012.
    </div>;
  }
  const javaContent = () => {
    return <div>
      Java is a set of computer software and specifications developed by Sun Microsystems, later acquired by Oracle
      Corporation, that provides a system for developing application software and deploying it in a cross-platform computing
      environment. Java is used in a wide variety of computing platforms from embedded devices and mobile phones to
      enterprise servers and supercomputers. While less common, Java applets run in secure, sandboxed environments to
      provide many features of native applications and can be embedded in HTML pages.
    </div>;
  }
  const vbNetcontent = () => {
    return <div>
      The command-line compiler, VBC.EXE, is installed as part of the freeware .NET
      Framework SDK. Mono also includes a command-line VB.NET compiler. The most recent version
      is VB 2012, which was released on August 15, 2012.
    </div>;
  }
  const xamarinContent = () => {
    return <div>
      Xamarin is a San Francisco, California based software company created in May
      2011[3] by the engineers that created Mono,[4] Mono for Android and MonoTouch that are
      cross-platform implementations of the Common Language Infrastructure (CLI) and Common
      Language Specifications (often called Microsoft .NET). With a C#-shared codebase,developers
      can use Xamarin tools to write native Android, iOS, and Windows apps with native user interfaces
      and share code across multiple platforms.[5] Xamarin has over 1 million developers in more
      than 120 countries around the World as of May 2015.
    </div>;
  }
  const aspNetContent = () => {
    return <div>
      ASP.NET is an open-source server-side web application framework designed for web
      development to produce dynamic web pages. It was developed by Microsoft to allow programmers
      to build dynamic web sites, web applications and web services. It was first released in January
      2002 with version 1.0 of the .NET Framework, and is the successor to Microsoft Active Server
      Pages (ASP) technology. ASP.NET is built on the Common Language Runtime (CLR), allowing
      programmers to write ASP.NET code using any supported .NET language. The ASP.NET SOAP extension
      framework allows ASP.NET components to process SOAP messages.
    </div>;
  }
  const mvcContent = () => {
    return <div>
      The ASP.NET MVC is a web application framework developed by Microsoft, which implements
      the modelviewcontroller (MVC) pattern. It is open-source software, apart from the ASP.NET Web
      Forms component which is proprietary. In the later versions of ASP.NET, ASP.NET MVC, ASP.NET Web
      API, and ASP.NET Web Pages (a platform using only Razor pages) will merge into a unified MVC 6.
      The project is called ASP.NET vNext.
    </div>;
  }
  const javaScriptContent = () => {
    return <div>
      JavaScript (JS) is an interpreted computer programming language. It was originally
      implemented as part of web browsers so that client-side scripts could interact with the
      user, control the browser, communicate asynchronously, and alter the document content that
      was displayed.[5] More recently, however, it has become common in both game development
      and the creation of desktop applications.
    </div>;
  }

  return (
    <div>
      <div className='row' id='header'>
        <label> Header Position </label>
        <div>
          <DropDownListComponent ref={headerPosition} dataSource={headerData} fields={fields} value={hdrVal} width={'150'} change={changeOrientationMode} />
        </div>
      </div>
      <div className='row' id='mode'>
        <label> Mode </label>
        <div>
          <DropDownListComponent ref={orientation} dataSource={orientationData} fields={fields} value={orientationVal} width={'150'} change={changeOverflowMode} />
        </div>
      </div>
      <br /><br />
      <TabComponent id='default' heightAdjustMode='None' height={150} width='700' ref={tabObj}>
        <TabItemsDirective>
          <TabItemDirective header={headerText[0]} content={htmlcontent} />
          <TabItemDirective header={headerText[1]} content={csharpContent} />
          <TabItemDirective header={headerText[2]} content={javaContent} />
          <TabItemDirective header={headerText[3]} content={vbNetcontent} />
          <TabItemDirective header={headerText[4]} content={xamarinContent} />
          <TabItemDirective header={headerText[5]} content={aspNetContent} />
          <TabItemDirective header={headerText[6]} content={mvcContent} />
          <TabItemDirective header={headerText[7]} content={javaScriptContent} />
        </TabItemsDirective>
      </TabComponent>
    </div>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<ReactApp />);
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Tab</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/material.css" rel="stylesheet" />
    <link href="index.css" rel="stylesheet" /> 
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    <div id='container'>
        <div id='element'>
                <div id='loader'>Loading</div>
        </div>
    </div>
</body>

</html>